﻿namespace Ozeki
{
    public record OzHfDownloadManifest
    {
        public string DownloadUrl { get; init; }
        public string FileName { get; init; }
        public string OutputPath { get; init; }
        public string ChecksumUrl { get; init; }
        public long Size { get; init; }

        internal OzHfDownloadManifest(string downloadUrl, string fileName, string outputPath, string checksumUrl, long size)
        {
            DownloadUrl = downloadUrl;
            FileName = fileName;
            OutputPath = outputPath;
            ChecksumUrl = checksumUrl;
            Size = size;
        }
    }
}
