﻿namespace Ozeki
{
    internal class OzHfProgressStream : Stream
    {
        private Stream _input = Stream.Null;
        private long _length = 0L;
        private long _position = 0L;
        public event EventHandler<OzHfProgressEventArgs> UpdateProgress;

        public OzHfProgressStream(Stream input)
        {
            _input = input;
            _length = input.Length;
        }
        public override void Flush()
        {
            throw new System.NotImplementedException();
        }

        public override long Seek(long offset, SeekOrigin origin)
        {
            throw new System.NotImplementedException();
        }

        public override void SetLength(long value)
        {
            throw new System.NotImplementedException();
        }

        public override int Read(byte[] buffer, int offset, int count)
        {
            int n = _input.Read(buffer, offset, count);
            _position += n;

            UpdateProgress?.Invoke(this, new OzHfProgressEventArgs(n));
            return n;
        }

        public override void Write(byte[] buffer, int offset, int count)
        {
            throw new System.NotImplementedException();
        }

        public override bool CanRead => true;
        public override bool CanSeek => false;
        public override bool CanWrite => false;
        public override long Length => _length;
        public override long Position
        {
            get { return _position; }
            set { throw new System.NotImplementedException(); }
        }
    }    
}
